<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.6"/>
<title>TIML: timlCNN.h File Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">TIML
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.6 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="annotated.html"><span>Data&#160;Structures</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>Globals</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Data Structures</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Enumerations</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&#160;</span>Enumerator</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&#160;</span>Groups</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(8)"><span class="SelectionMark">&#160;</span>Pages</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_4f218e5c1c68a8760266841df915118e.html">src</a></li><li class="navelem"><a class="el" href="dir_e5def28db4ba0142cedf1af2d851f321.html">common</a></li><li class="navelem"><a class="el" href="dir_1d5bd1a67e620b1dd620c8f99cd54336.html">cnn</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#nested-classes">Data Structures</a> &#124;
<a href="#define-members">Macros</a> &#124;
<a href="#typedef-members">Typedefs</a> &#124;
<a href="#enum-members">Enumerations</a> &#124;
<a href="#func-members">Functions</a>  </div>
  <div class="headertitle">
<div class="title">timlCNN.h File Reference</div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock"><code>#include &quot;<a class="el" href="timlUtil_8h_source.html">timlUtil.h</a>&quot;</code><br/>
</div>
<p><a href="timlCNN_8h_source.html">Go to the source code of this file.</a></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="nested-classes"></a>
Data Structures</h2></td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structtimlCNNPoolingParams.html">timlCNNPoolingParams</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structtimlCNNLinearParams.html">timlCNNLinearParams</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structtimlCNNDataSet.html">timlCNNDataSet</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structtimlCNNConvParams.html">timlCNNConvParams</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structtimlCNNNonlinearParams.html">timlCNNNonlinearParams</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structtimlCNNNormParams.html">timlCNNNormParams</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structtimlCNNInputParams.html">timlCNNInputParams</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structtimlCNNDropoutParams.html">timlCNNDropoutParams</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct__timlCNNLayer__.html">_timlCNNLayer_</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structtimlCNNTrainingParams.html">timlCNNTrainingParams</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct__timlConvNeuralNetwork__.html">_timlConvNeuralNetwork_</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="define-members"></a>
Macros</h2></td></tr>
<tr class="memitem:gad34be1f546d627b82db121fec71275c6"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="gad34be1f546d627b82db121fec71275c6"></a>
#define&#160;</td><td class="memItemRight" valign="bottom"><b>ERROR_CNN_OFFSET</b>&#160;&#160;&#160;4000</td></tr>
<tr class="separator:gad34be1f546d627b82db121fec71275c6"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="typedef-members"></a>
Typedefs</h2></td></tr>
<tr class="memitem:ga7f576e8746f102120e854ad60bc0bcb3"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ga7f576e8746f102120e854ad60bc0bcb3"></a>
typedef struct <a class="el" href="struct__timlCNNLayer__.html">_timlCNNLayer_</a>&#160;</td><td class="memItemRight" valign="bottom"><b>timlCNNLayer</b></td></tr>
<tr class="separator:ga7f576e8746f102120e854ad60bc0bcb3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga579bf3bae8fd7331ed0050fdd7a02ada"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ga579bf3bae8fd7331ed0050fdd7a02ada"></a>
typedef struct <br class="typebreak"/>
<a class="el" href="struct__timlConvNeuralNetwork__.html">_timlConvNeuralNetwork_</a>&#160;</td><td class="memItemRight" valign="bottom"><b>timlConvNeuralNetwork</b></td></tr>
<tr class="separator:ga579bf3bae8fd7331ed0050fdd7a02ada"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="enum-members"></a>
Enumerations</h2></td></tr>
<tr class="memitem:gad4359081e96288d458988f895e32298b"><td class="memItemLeft" align="right" valign="top">enum &#160;</td><td class="memItemRight" valign="bottom"><b>timlCNNError</b> { <br/>
&#160;&#160;<b>ERROR_CNN_FEATURE_MAP_SIZE</b> = ERROR_CNN_OFFSET, 
<b>ERROR_CNN_FEATURE_MAP_CHANNEL</b>, 
<b>ERROR_CNN_ALLOCATION</b>, 
<b>ERROR_CNN_LAYER_ALLOCATION</b>, 
<br/>
&#160;&#160;<b>ERROR_CNN_TEAM_ALLOCATION</b>, 
<b>ERROR_CNN_CONV_LAYER_KERNEL_SIZE</b>, 
<b>ERROR_CNN_CONV_LAYER_PAD_SIZE</b>, 
<b>ERROR_CNN_CONV_LAYER_STRIDE_SIZE</b>, 
<br/>
&#160;&#160;<b>ERROR_CNN_POOLING_LAYER_SCALE_SIZE</b>, 
<b>ERROR_CNN_POOLING_LAYER_PAD_SIZE</b>, 
<b>ERROR_CNN_POOLING_LAYER_STRIDE_SIZE</b>, 
<b>ERROR_CNN_INPUT_LAYER_PARAMS</b>, 
<br/>
&#160;&#160;<b>ERROR_CNN_LINEAR_LAYER_DIM</b>, 
<b>ERROR_CNN_NORM_LAYER_PARAMS</b>, 
<b>ERROR_CNN_DROPOUT_LAYER_PARAMS</b>, 
<b>ERROR_CNN_NULL_PTR</b>, 
<br/>
&#160;&#160;<b>ERROR_CNN_EMPTY</b>, 
<b>ERROR_CNN_READ_FILE</b>, 
<b>ERROR_CNN_CLASS</b>
<br/>
 }</td></tr>
<tr class="separator:gad4359081e96288d458988f895e32298b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga5b06483a9007c67f578ec7fb1067563a"><td class="memItemLeft" align="right" valign="top">enum &#160;</td><td class="memItemRight" valign="bottom"><b>timlCNNNormType</b> { <b>CNN_InterChannel</b>, 
<b>CNN_IntraChannel</b>
 }</td></tr>
<tr class="separator:ga5b06483a9007c67f578ec7fb1067563a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gae4d6107f95fb2e5576f8ab124a16c1f8"><td class="memItemLeft" align="right" valign="top">enum &#160;</td><td class="memItemRight" valign="bottom"><b>timlCNNLayerType</b> { <br/>
&#160;&#160;<b>CNN_Input</b>, 
<b>CNN_Conv</b>, 
<b>CNN_Pooling</b>, 
<b>CNN_Nonlinear</b>, 
<br/>
&#160;&#160;<b>CNN_Linear</b>, 
<b>CNN_Norm</b>, 
<b>CNN_Dropout</b>
<br/>
 }</td></tr>
<tr class="separator:gae4d6107f95fb2e5576f8ab124a16c1f8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga60d7100c8c193bb6dd57ba344c44544e"><td class="memItemLeft" align="right" valign="top">enum &#160;</td><td class="memItemRight" valign="bottom"><b>timlCNNPoolingType</b> { <b>CNN_MaxPooling</b>, 
<b>CNN_MeanPooling</b>
 }</td></tr>
<tr class="separator:ga60d7100c8c193bb6dd57ba344c44544e"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="func-members"></a>
Functions</h2></td></tr>
<tr class="memitem:ga505ab9c8b9e0044ff0c38452c4ac9fdb"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#ga505ab9c8b9e0044ff0c38452c4ac9fdb">timlCNNInputShareParams</a> (<a class="el" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *cnn, <a class="el" href="struct__timlCNNLayer__.html">timlCNNLayer</a> *layer)</td></tr>
<tr class="memdesc:ga505ab9c8b9e0044ff0c38452c4ac9fdb"><td class="mdescLeft">&#160;</td><td class="mdescRight">Share the mean with other input layer.  <a href="group__cnn.html#ga505ab9c8b9e0044ff0c38452c4ac9fdb">More...</a><br/></td></tr>
<tr class="separator:ga505ab9c8b9e0044ff0c38452c4ac9fdb"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga2db8ecc8b9fd11b5575915aab0635639"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#ga2db8ecc8b9fd11b5575915aab0635639">timlCNNConvShareParams</a> (<a class="el" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *cnnShare, <a class="el" href="struct__timlCNNLayer__.html">timlCNNLayer</a> *layer)</td></tr>
<tr class="memdesc:ga2db8ecc8b9fd11b5575915aab0635639"><td class="mdescLeft">&#160;</td><td class="mdescRight">Share the parameters with other conv layer.  <a href="group__cnn.html#ga2db8ecc8b9fd11b5575915aab0635639">More...</a><br/></td></tr>
<tr class="separator:ga2db8ecc8b9fd11b5575915aab0635639"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga0bf4e74ce83086b2a11e53cc9ef608dc"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#ga0bf4e74ce83086b2a11e53cc9ef608dc">timlCNNLinearShareParams</a> (<a class="el" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *cnnShare, <a class="el" href="struct__timlCNNLayer__.html">timlCNNLayer</a> *layer)</td></tr>
<tr class="memdesc:ga0bf4e74ce83086b2a11e53cc9ef608dc"><td class="mdescLeft">&#160;</td><td class="mdescRight">Share the parameters with other linear layer.  <a href="group__cnn.html#ga0bf4e74ce83086b2a11e53cc9ef608dc">More...</a><br/></td></tr>
<tr class="separator:ga0bf4e74ce83086b2a11e53cc9ef608dc"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga9421f0328417cfcbd3c872413a22bee4"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#ga9421f0328417cfcbd3c872413a22bee4">timlCNNConvInitialize</a> (<a class="el" href="struct__timlCNNLayer__.html">timlCNNLayer</a> *layer)</td></tr>
<tr class="memdesc:ga9421f0328417cfcbd3c872413a22bee4"><td class="mdescLeft">&#160;</td><td class="mdescRight">Initialize the conv layer.  <a href="group__cnn.html#ga9421f0328417cfcbd3c872413a22bee4">More...</a><br/></td></tr>
<tr class="separator:ga9421f0328417cfcbd3c872413a22bee4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gac2e87d5f63f9172841fd1aa81bd33056"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#gac2e87d5f63f9172841fd1aa81bd33056">timlCNNLinearInitialize</a> (<a class="el" href="struct__timlCNNLayer__.html">timlCNNLayer</a> *layer)</td></tr>
<tr class="memdesc:gac2e87d5f63f9172841fd1aa81bd33056"><td class="mdescLeft">&#160;</td><td class="mdescRight">Initialize the linear layer.  <a href="group__cnn.html#gac2e87d5f63f9172841fd1aa81bd33056">More...</a><br/></td></tr>
<tr class="separator:gac2e87d5f63f9172841fd1aa81bd33056"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga168c7d5447be30dbf876b55a5d5c64fa"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#ga168c7d5447be30dbf876b55a5d5c64fa">timlCNNNonlinearInitialize</a> (<a class="el" href="struct__timlCNNLayer__.html">timlCNNLayer</a> *layer)</td></tr>
<tr class="memdesc:ga168c7d5447be30dbf876b55a5d5c64fa"><td class="mdescLeft">&#160;</td><td class="mdescRight">Initialize the nonlinear layer.  <a href="group__cnn.html#ga168c7d5447be30dbf876b55a5d5c64fa">More...</a><br/></td></tr>
<tr class="separator:ga168c7d5447be30dbf876b55a5d5c64fa"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga364f01a881e95325e74696f87ea80bb3"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#ga364f01a881e95325e74696f87ea80bb3">timlCNNInputInitialize</a> (<a class="el" href="struct__timlCNNLayer__.html">timlCNNLayer</a> *layer)</td></tr>
<tr class="memdesc:ga364f01a881e95325e74696f87ea80bb3"><td class="mdescLeft">&#160;</td><td class="mdescRight">Initialize the input layer.  <a href="group__cnn.html#ga364f01a881e95325e74696f87ea80bb3">More...</a><br/></td></tr>
<tr class="separator:ga364f01a881e95325e74696f87ea80bb3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga881ee558df99885ecad25cb94135d0c2"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#ga881ee558df99885ecad25cb94135d0c2">timlCNNPoolingInitialize</a> (<a class="el" href="struct__timlCNNLayer__.html">timlCNNLayer</a> *layer)</td></tr>
<tr class="memdesc:ga881ee558df99885ecad25cb94135d0c2"><td class="mdescLeft">&#160;</td><td class="mdescRight">Initialize the pooling layer.  <a href="group__cnn.html#ga881ee558df99885ecad25cb94135d0c2">More...</a><br/></td></tr>
<tr class="separator:ga881ee558df99885ecad25cb94135d0c2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga7b9ecc1fde2e10463adb310591b6d1a6"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#ga7b9ecc1fde2e10463adb310591b6d1a6">timlCNNNormInitialize</a> (<a class="el" href="struct__timlCNNLayer__.html">timlCNNLayer</a> *layer)</td></tr>
<tr class="memdesc:ga7b9ecc1fde2e10463adb310591b6d1a6"><td class="mdescLeft">&#160;</td><td class="mdescRight">Initialize the norm layer.  <a href="group__cnn.html#ga7b9ecc1fde2e10463adb310591b6d1a6">More...</a><br/></td></tr>
<tr class="separator:ga7b9ecc1fde2e10463adb310591b6d1a6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga34482801429f6f71ab950f0bd7ffc632"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#ga34482801429f6f71ab950f0bd7ffc632">timlCNNDropoutInitialize</a> (<a class="el" href="struct__timlCNNLayer__.html">timlCNNLayer</a> *layer)</td></tr>
<tr class="memdesc:ga34482801429f6f71ab950f0bd7ffc632"><td class="mdescLeft">&#160;</td><td class="mdescRight">Initialize the dropout layer.  <a href="group__cnn.html#ga34482801429f6f71ab950f0bd7ffc632">More...</a><br/></td></tr>
<tr class="separator:ga34482801429f6f71ab950f0bd7ffc632"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gadbaf2cae65f9fb891d4055b6bee850b3"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#gadbaf2cae65f9fb891d4055b6bee850b3">timlCNNBackPropagation</a> (<a class="el" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *cnn, <a class="el" href="struct__timlCNNLayer__.html">timlCNNLayer</a> *layer)</td></tr>
<tr class="memdesc:gadbaf2cae65f9fb891d4055b6bee850b3"><td class="mdescLeft">&#160;</td><td class="mdescRight">Back propagate the gradient from layer to the first layer of the cnn.  <a href="group__cnn.html#gadbaf2cae65f9fb891d4055b6bee850b3">More...</a><br/></td></tr>
<tr class="separator:gadbaf2cae65f9fb891d4055b6bee850b3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga87b85708ba010d15ad446b10bb948f38"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#ga87b85708ba010d15ad446b10bb948f38">timlCNNConvBackPropagation</a> (<a class="el" href="struct__timlCNNLayer__.html">timlCNNLayer</a> *layer)</td></tr>
<tr class="memdesc:ga87b85708ba010d15ad446b10bb948f38"><td class="mdescLeft">&#160;</td><td class="mdescRight">Back propagate the gradient from the conv layer to the previous layer.  <a href="group__cnn.html#ga87b85708ba010d15ad446b10bb948f38">More...</a><br/></td></tr>
<tr class="separator:ga87b85708ba010d15ad446b10bb948f38"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gaf6e6fabff921002175a648a096baf053"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#gaf6e6fabff921002175a648a096baf053">timlCNNNormBackPropagation</a> (<a class="el" href="struct__timlCNNLayer__.html">timlCNNLayer</a> *layer)</td></tr>
<tr class="memdesc:gaf6e6fabff921002175a648a096baf053"><td class="mdescLeft">&#160;</td><td class="mdescRight">Back propagate the gradient from the norm layer to the previous layer.  <a href="group__cnn.html#gaf6e6fabff921002175a648a096baf053">More...</a><br/></td></tr>
<tr class="separator:gaf6e6fabff921002175a648a096baf053"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gac41d0764628d4c688ddc92616030f91b"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#gac41d0764628d4c688ddc92616030f91b">timlCNNPoolingBackPropagation</a> (<a class="el" href="struct__timlCNNLayer__.html">timlCNNLayer</a> *layer)</td></tr>
<tr class="memdesc:gac41d0764628d4c688ddc92616030f91b"><td class="mdescLeft">&#160;</td><td class="mdescRight">Back propagate the gradient from the pooling layer to the previous layer.  <a href="group__cnn.html#gac41d0764628d4c688ddc92616030f91b">More...</a><br/></td></tr>
<tr class="separator:gac41d0764628d4c688ddc92616030f91b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga4d7e5c73f5d262b8b1297ac84b74452f"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#ga4d7e5c73f5d262b8b1297ac84b74452f">timlCNNMaxPoolingBackPropagation</a> (<a class="el" href="struct__timlCNNLayer__.html">timlCNNLayer</a> *layer)</td></tr>
<tr class="memdesc:ga4d7e5c73f5d262b8b1297ac84b74452f"><td class="mdescLeft">&#160;</td><td class="mdescRight">Back propagate the gradient from the max pooling layer to the previous layer.  <a href="group__cnn.html#ga4d7e5c73f5d262b8b1297ac84b74452f">More...</a><br/></td></tr>
<tr class="separator:ga4d7e5c73f5d262b8b1297ac84b74452f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gaff7fd1cc8df10980b369ed822116d62d"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#gaff7fd1cc8df10980b369ed822116d62d">timlCNNMeanPoolingBackPropagation</a> (<a class="el" href="struct__timlCNNLayer__.html">timlCNNLayer</a> *layer)</td></tr>
<tr class="memdesc:gaff7fd1cc8df10980b369ed822116d62d"><td class="mdescLeft">&#160;</td><td class="mdescRight">Back propagate the gradient from the mean pooling layer to the previous layer.  <a href="group__cnn.html#gaff7fd1cc8df10980b369ed822116d62d">More...</a><br/></td></tr>
<tr class="separator:gaff7fd1cc8df10980b369ed822116d62d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gac7ac76fabbf31210f7179da92ae435c6"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#gac7ac76fabbf31210f7179da92ae435c6">timlCNNNonlinearBackPropagation</a> (<a class="el" href="struct__timlCNNLayer__.html">timlCNNLayer</a> *layer)</td></tr>
<tr class="memdesc:gac7ac76fabbf31210f7179da92ae435c6"><td class="mdescLeft">&#160;</td><td class="mdescRight">Back propagate the gradient from the nonlinear layer to the previous layer.  <a href="group__cnn.html#gac7ac76fabbf31210f7179da92ae435c6">More...</a><br/></td></tr>
<tr class="separator:gac7ac76fabbf31210f7179da92ae435c6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga070c37ad3fb8ea7186dc35d606575d59"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#ga070c37ad3fb8ea7186dc35d606575d59">timlCNNLinearBackPropagation</a> (<a class="el" href="struct__timlCNNLayer__.html">timlCNNLayer</a> *layer)</td></tr>
<tr class="memdesc:ga070c37ad3fb8ea7186dc35d606575d59"><td class="mdescLeft">&#160;</td><td class="mdescRight">Back propagate the gradient from the linear layer to the previous layer.  <a href="group__cnn.html#ga070c37ad3fb8ea7186dc35d606575d59">More...</a><br/></td></tr>
<tr class="separator:ga070c37ad3fb8ea7186dc35d606575d59"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga4212a24620cb1bbadbd357e9e098df96"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#ga4212a24620cb1bbadbd357e9e098df96">timlCNNDropoutBackPropagation</a> (<a class="el" href="struct__timlCNNLayer__.html">timlCNNLayer</a> *layer)</td></tr>
<tr class="memdesc:ga4212a24620cb1bbadbd357e9e098df96"><td class="mdescLeft">&#160;</td><td class="mdescRight">Back propagate the gradient from the dropout layer to the previous layer.  <a href="group__cnn.html#ga4212a24620cb1bbadbd357e9e098df96">More...</a><br/></td></tr>
<tr class="separator:ga4212a24620cb1bbadbd357e9e098df96"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga3a460390fe11150e8543fd4278befa30"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#ga3a460390fe11150e8543fd4278befa30">timlCNNCostWithLabel</a> (<a class="el" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *cnn, int label, float *cost, <a class="el" href="struct__timlCNNLayer__.html">timlCNNLayer</a> **bpStartLayer)</td></tr>
<tr class="memdesc:ga3a460390fe11150e8543fd4278befa30"><td class="mdescLeft">&#160;</td><td class="mdescRight">Calculate the cost based on the cnn output and the label.  <a href="group__cnn.html#ga3a460390fe11150e8543fd4278befa30">More...</a><br/></td></tr>
<tr class="separator:ga3a460390fe11150e8543fd4278befa30"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gaa88dc52f16802468957c8e9c72abc090"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#gaa88dc52f16802468957c8e9c72abc090">timlCNNForwardPropagation</a> (<a class="el" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *cnn, float *data, int dim)</td></tr>
<tr class="memdesc:gaa88dc52f16802468957c8e9c72abc090"><td class="mdescLeft">&#160;</td><td class="mdescRight">Forward propagate data to the CNN.  <a href="group__cnn.html#gaa88dc52f16802468957c8e9c72abc090">More...</a><br/></td></tr>
<tr class="separator:gaa88dc52f16802468957c8e9c72abc090"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gabeb3923cc2778e76f7a3007381e20430"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#gabeb3923cc2778e76f7a3007381e20430">timlCNNInputForwardPropagation</a> (<a class="el" href="struct__timlCNNLayer__.html">timlCNNLayer</a> *layer, float *data, int dim)</td></tr>
<tr class="memdesc:gabeb3923cc2778e76f7a3007381e20430"><td class="mdescLeft">&#160;</td><td class="mdescRight">Forward propagate data to the the input layer.  <a href="group__cnn.html#gabeb3923cc2778e76f7a3007381e20430">More...</a><br/></td></tr>
<tr class="separator:gabeb3923cc2778e76f7a3007381e20430"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gad366264a3e921fb6bd24e43e2f187ad9"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#gad366264a3e921fb6bd24e43e2f187ad9">timlCNNLinearForwardPropagation</a> (<a class="el" href="struct__timlCNNLayer__.html">timlCNNLayer</a> *prevLayer)</td></tr>
<tr class="memdesc:gad366264a3e921fb6bd24e43e2f187ad9"><td class="mdescLeft">&#160;</td><td class="mdescRight">Forward propagate form layer to layer-&gt;next.  <a href="group__cnn.html#gad366264a3e921fb6bd24e43e2f187ad9">More...</a><br/></td></tr>
<tr class="separator:gad366264a3e921fb6bd24e43e2f187ad9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga6dc7fbc079a50aeefdb49b8fd69815de"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#ga6dc7fbc079a50aeefdb49b8fd69815de">timlCNNDropoutForwardPropagation</a> (<a class="el" href="struct__timlCNNLayer__.html">timlCNNLayer</a> *prevLayer)</td></tr>
<tr class="memdesc:ga6dc7fbc079a50aeefdb49b8fd69815de"><td class="mdescLeft">&#160;</td><td class="mdescRight">Forward propagate form layer to layer-&gt;next.  <a href="group__cnn.html#ga6dc7fbc079a50aeefdb49b8fd69815de">More...</a><br/></td></tr>
<tr class="separator:ga6dc7fbc079a50aeefdb49b8fd69815de"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga846509e51a95fd30af7893a8a3eae597"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#ga846509e51a95fd30af7893a8a3eae597">timlCNNNonlinearForwardPropagation</a> (<a class="el" href="struct__timlCNNLayer__.html">timlCNNLayer</a> *prevLayer)</td></tr>
<tr class="memdesc:ga846509e51a95fd30af7893a8a3eae597"><td class="mdescLeft">&#160;</td><td class="mdescRight">Forward propagate form layer to layer-&gt;next.  <a href="group__cnn.html#ga846509e51a95fd30af7893a8a3eae597">More...</a><br/></td></tr>
<tr class="separator:ga846509e51a95fd30af7893a8a3eae597"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga469289dea763db5315affecaa14126c1"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#ga469289dea763db5315affecaa14126c1">timlCNNNormForwardPropagation</a> (<a class="el" href="struct__timlCNNLayer__.html">timlCNNLayer</a> *prevLayer)</td></tr>
<tr class="memdesc:ga469289dea763db5315affecaa14126c1"><td class="mdescLeft">&#160;</td><td class="mdescRight">Forward propagate form layer to layer-&gt;next.  <a href="group__cnn.html#ga469289dea763db5315affecaa14126c1">More...</a><br/></td></tr>
<tr class="separator:ga469289dea763db5315affecaa14126c1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga16c5a2314091dd1098b36a8f195bd307"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#ga16c5a2314091dd1098b36a8f195bd307">timlCNNPoolingForwardPropagation</a> (<a class="el" href="struct__timlCNNLayer__.html">timlCNNLayer</a> *prevLayer)</td></tr>
<tr class="memdesc:ga16c5a2314091dd1098b36a8f195bd307"><td class="mdescLeft">&#160;</td><td class="mdescRight">Forward propagate form layer to layer-&gt;next.  <a href="group__cnn.html#ga16c5a2314091dd1098b36a8f195bd307">More...</a><br/></td></tr>
<tr class="separator:ga16c5a2314091dd1098b36a8f195bd307"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gac594a5259bbac18de41dfa3db702a5a6"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#gac594a5259bbac18de41dfa3db702a5a6">timlCNNMaxPoolingForwardPropagation</a> (<a class="el" href="struct__timlCNNLayer__.html">timlCNNLayer</a> *prevLayer)</td></tr>
<tr class="memdesc:gac594a5259bbac18de41dfa3db702a5a6"><td class="mdescLeft">&#160;</td><td class="mdescRight">Forward propagate form layer to layer-&gt;next.  <a href="group__cnn.html#gac594a5259bbac18de41dfa3db702a5a6">More...</a><br/></td></tr>
<tr class="separator:gac594a5259bbac18de41dfa3db702a5a6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga63da450601424d0163ef93e945aebe47"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#ga63da450601424d0163ef93e945aebe47">timlCNNMeanPoolingForwardPropagation</a> (<a class="el" href="struct__timlCNNLayer__.html">timlCNNLayer</a> *prevLayer)</td></tr>
<tr class="memdesc:ga63da450601424d0163ef93e945aebe47"><td class="mdescLeft">&#160;</td><td class="mdescRight">Forward propagate form layer to layer-&gt;next.  <a href="group__cnn.html#ga63da450601424d0163ef93e945aebe47">More...</a><br/></td></tr>
<tr class="separator:ga63da450601424d0163ef93e945aebe47"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga067cdd0cbd03bc3a280e2d759d85a2e2"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#ga067cdd0cbd03bc3a280e2d759d85a2e2">timlCNNConvForwardPropagation</a> (<a class="el" href="struct__timlCNNLayer__.html">timlCNNLayer</a> *prevLayer)</td></tr>
<tr class="memdesc:ga067cdd0cbd03bc3a280e2d759d85a2e2"><td class="mdescLeft">&#160;</td><td class="mdescRight">Forward propagate form layer to layer-&gt;next.  <a href="group__cnn.html#ga067cdd0cbd03bc3a280e2d759d85a2e2">More...</a><br/></td></tr>
<tr class="separator:ga067cdd0cbd03bc3a280e2d759d85a2e2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga42e19dc879644325d201d5f6e7a52d5d"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#ga42e19dc879644325d201d5f6e7a52d5d">timlCNNDeleteConvLayer</a> (<a class="el" href="struct__timlCNNLayer__.html">timlCNNLayer</a> *layer)</td></tr>
<tr class="memdesc:ga42e19dc879644325d201d5f6e7a52d5d"><td class="mdescLeft">&#160;</td><td class="mdescRight">Delete conv layer.  <a href="group__cnn.html#ga42e19dc879644325d201d5f6e7a52d5d">More...</a><br/></td></tr>
<tr class="separator:ga42e19dc879644325d201d5f6e7a52d5d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gaa56d800b6375f22e191445747a85756b"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#gaa56d800b6375f22e191445747a85756b">timlCNNDeleteInputLayer</a> (<a class="el" href="struct__timlCNNLayer__.html">timlCNNLayer</a> *layer)</td></tr>
<tr class="memdesc:gaa56d800b6375f22e191445747a85756b"><td class="mdescLeft">&#160;</td><td class="mdescRight">Delete input layer.  <a href="group__cnn.html#gaa56d800b6375f22e191445747a85756b">More...</a><br/></td></tr>
<tr class="separator:gaa56d800b6375f22e191445747a85756b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga480032813fd323e262d6d97c80871fe3"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#ga480032813fd323e262d6d97c80871fe3">timlCNNDeleteNonlinearLayer</a> (<a class="el" href="struct__timlCNNLayer__.html">timlCNNLayer</a> *layer)</td></tr>
<tr class="memdesc:ga480032813fd323e262d6d97c80871fe3"><td class="mdescLeft">&#160;</td><td class="mdescRight">Delete nonlinear layer.  <a href="group__cnn.html#ga480032813fd323e262d6d97c80871fe3">More...</a><br/></td></tr>
<tr class="separator:ga480032813fd323e262d6d97c80871fe3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gadbce74b8b0cb84174e89e4d4f07bd095"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#gadbce74b8b0cb84174e89e4d4f07bd095">timlCNNDeleteNormLayer</a> (<a class="el" href="struct__timlCNNLayer__.html">timlCNNLayer</a> *layer)</td></tr>
<tr class="memdesc:gadbce74b8b0cb84174e89e4d4f07bd095"><td class="mdescLeft">&#160;</td><td class="mdescRight">Delete norm layer.  <a href="group__cnn.html#gadbce74b8b0cb84174e89e4d4f07bd095">More...</a><br/></td></tr>
<tr class="separator:gadbce74b8b0cb84174e89e4d4f07bd095"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gad4eb2d99ee7c96bb589999146c31cfff"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#gad4eb2d99ee7c96bb589999146c31cfff">timlCNNDeletePoolingLayer</a> (<a class="el" href="struct__timlCNNLayer__.html">timlCNNLayer</a> *layer)</td></tr>
<tr class="memdesc:gad4eb2d99ee7c96bb589999146c31cfff"><td class="mdescLeft">&#160;</td><td class="mdescRight">Delete pooling layer.  <a href="group__cnn.html#gad4eb2d99ee7c96bb589999146c31cfff">More...</a><br/></td></tr>
<tr class="separator:gad4eb2d99ee7c96bb589999146c31cfff"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga1b1477cff7bbdeb93aaffbf18f59f1cd"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#ga1b1477cff7bbdeb93aaffbf18f59f1cd">timlCNNDeleteLinearLayer</a> (<a class="el" href="struct__timlCNNLayer__.html">timlCNNLayer</a> *layer)</td></tr>
<tr class="memdesc:ga1b1477cff7bbdeb93aaffbf18f59f1cd"><td class="mdescLeft">&#160;</td><td class="mdescRight">Delete linear layer.  <a href="group__cnn.html#ga1b1477cff7bbdeb93aaffbf18f59f1cd">More...</a><br/></td></tr>
<tr class="separator:ga1b1477cff7bbdeb93aaffbf18f59f1cd"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga200dffa5338c0dfbaf279c3798e7e97c"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#ga200dffa5338c0dfbaf279c3798e7e97c">timlCNNDeleteDropoutLayer</a> (<a class="el" href="struct__timlCNNLayer__.html">timlCNNLayer</a> *layer)</td></tr>
<tr class="memdesc:ga200dffa5338c0dfbaf279c3798e7e97c"><td class="mdescLeft">&#160;</td><td class="mdescRight">Delete dropout layer.  <a href="group__cnn.html#ga200dffa5338c0dfbaf279c3798e7e97c">More...</a><br/></td></tr>
<tr class="separator:ga200dffa5338c0dfbaf279c3798e7e97c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gaf1a19381c3d653bd4f53e65bdae708a7"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#gaf1a19381c3d653bd4f53e65bdae708a7">timlCNNResetConvLayer</a> (<a class="el" href="struct__timlCNNLayer__.html">timlCNNLayer</a> *layer)</td></tr>
<tr class="memdesc:gaf1a19381c3d653bd4f53e65bdae708a7"><td class="mdescLeft">&#160;</td><td class="mdescRight">Reset conv layer.  <a href="group__cnn.html#gaf1a19381c3d653bd4f53e65bdae708a7">More...</a><br/></td></tr>
<tr class="separator:gaf1a19381c3d653bd4f53e65bdae708a7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga6eda15d8d34f275901cf2517d2115122"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#ga6eda15d8d34f275901cf2517d2115122">timlCNNResetInputLayer</a> (<a class="el" href="struct__timlCNNLayer__.html">timlCNNLayer</a> *layer)</td></tr>
<tr class="memdesc:ga6eda15d8d34f275901cf2517d2115122"><td class="mdescLeft">&#160;</td><td class="mdescRight">Reset input layer.  <a href="group__cnn.html#ga6eda15d8d34f275901cf2517d2115122">More...</a><br/></td></tr>
<tr class="separator:ga6eda15d8d34f275901cf2517d2115122"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga0db6e46b341b13992dc3283580a04d69"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#ga0db6e46b341b13992dc3283580a04d69">timlCNNResetLinearLayer</a> (<a class="el" href="struct__timlCNNLayer__.html">timlCNNLayer</a> *layer)</td></tr>
<tr class="memdesc:ga0db6e46b341b13992dc3283580a04d69"><td class="mdescLeft">&#160;</td><td class="mdescRight">Reset linear layer.  <a href="group__cnn.html#ga0db6e46b341b13992dc3283580a04d69">More...</a><br/></td></tr>
<tr class="separator:ga0db6e46b341b13992dc3283580a04d69"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga42e5c74e47146191ac0433ea68716d43"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#ga42e5c74e47146191ac0433ea68716d43">timlCNNResetNonlinearLayer</a> (<a class="el" href="struct__timlCNNLayer__.html">timlCNNLayer</a> *layer)</td></tr>
<tr class="memdesc:ga42e5c74e47146191ac0433ea68716d43"><td class="mdescLeft">&#160;</td><td class="mdescRight">Reset nonlinear layer.  <a href="group__cnn.html#ga42e5c74e47146191ac0433ea68716d43">More...</a><br/></td></tr>
<tr class="separator:ga42e5c74e47146191ac0433ea68716d43"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gadc089257aa2deeb115cb829c1b02eddc"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#gadc089257aa2deeb115cb829c1b02eddc">timlCNNResetNormLayer</a> (<a class="el" href="struct__timlCNNLayer__.html">timlCNNLayer</a> *layer)</td></tr>
<tr class="memdesc:gadc089257aa2deeb115cb829c1b02eddc"><td class="mdescLeft">&#160;</td><td class="mdescRight">Reset norm layer.  <a href="group__cnn.html#gadc089257aa2deeb115cb829c1b02eddc">More...</a><br/></td></tr>
<tr class="separator:gadc089257aa2deeb115cb829c1b02eddc"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gabb293d19ee0e655c359d9a327dd58fba"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#gabb293d19ee0e655c359d9a327dd58fba">timlCNNResetPoolingLayer</a> (<a class="el" href="struct__timlCNNLayer__.html">timlCNNLayer</a> *layer)</td></tr>
<tr class="memdesc:gabb293d19ee0e655c359d9a327dd58fba"><td class="mdescLeft">&#160;</td><td class="mdescRight">Reset pooling layer.  <a href="group__cnn.html#gabb293d19ee0e655c359d9a327dd58fba">More...</a><br/></td></tr>
<tr class="separator:gabb293d19ee0e655c359d9a327dd58fba"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gabdea1474b4f7b52d3c18681f1ce777f3"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#gabdea1474b4f7b52d3c18681f1ce777f3">timlCNNUpdateParams</a> (<a class="el" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *cnn)</td></tr>
<tr class="memdesc:gabdea1474b4f7b52d3c18681f1ce777f3"><td class="mdescLeft">&#160;</td><td class="mdescRight">Update the parameters of the cnn.  <a href="group__cnn.html#gabdea1474b4f7b52d3c18681f1ce777f3">More...</a><br/></td></tr>
<tr class="separator:gabdea1474b4f7b52d3c18681f1ce777f3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga09ce4c81b71d2a41958565f7b2dd0827"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#ga09ce4c81b71d2a41958565f7b2dd0827">timlCNNLinearUpdateParams</a> (<a class="el" href="struct__timlCNNLayer__.html">timlCNNLayer</a> *layer)</td></tr>
<tr class="memdesc:ga09ce4c81b71d2a41958565f7b2dd0827"><td class="mdescLeft">&#160;</td><td class="mdescRight">Update the parameters of the linear layer.  <a href="group__cnn.html#ga09ce4c81b71d2a41958565f7b2dd0827">More...</a><br/></td></tr>
<tr class="separator:ga09ce4c81b71d2a41958565f7b2dd0827"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga44339623d7eb830c865bd477e0865f2d"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#ga44339623d7eb830c865bd477e0865f2d">timlCNNConvUpdateParams</a> (<a class="el" href="struct__timlCNNLayer__.html">timlCNNLayer</a> *layer)</td></tr>
<tr class="memdesc:ga44339623d7eb830c865bd477e0865f2d"><td class="mdescLeft">&#160;</td><td class="mdescRight">Update the parameters of the conv layer.  <a href="group__cnn.html#ga44339623d7eb830c865bd477e0865f2d">More...</a><br/></td></tr>
<tr class="separator:ga44339623d7eb830c865bd477e0865f2d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gae9314b0e5476ec7b5b5c76aa6a7b0a53"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#gae9314b0e5476ec7b5b5c76aa6a7b0a53">timlCNNConvWriteToFile</a> (FILE *fp1, FILE *fp2, FILE *fp3, <a class="el" href="struct__timlCNNLayer__.html">timlCNNLayer</a> *layer, <a class="el" href="group__util.html#ga8e44b2a87636024736da04ae5a53c1c9">timlUtilParamsLevel</a> level, const char *name, const char *floatFormat, const char *intFormat)</td></tr>
<tr class="memdesc:gae9314b0e5476ec7b5b5c76aa6a7b0a53"><td class="mdescLeft">&#160;</td><td class="mdescRight">Write the conv layer to file(s)  <a href="group__cnn.html#gae9314b0e5476ec7b5b5c76aa6a7b0a53">More...</a><br/></td></tr>
<tr class="separator:gae9314b0e5476ec7b5b5c76aa6a7b0a53"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga79413c2f550a5c73ff855aea1c1e8782"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#ga79413c2f550a5c73ff855aea1c1e8782">timlCNNNonlinearWriteToFile</a> (FILE *fp1, FILE *fp2, FILE *fp3, <a class="el" href="struct__timlCNNLayer__.html">timlCNNLayer</a> *layer, <a class="el" href="group__util.html#ga8e44b2a87636024736da04ae5a53c1c9">timlUtilParamsLevel</a> level, const char *name, const char *floatFormat, const char *intFormat)</td></tr>
<tr class="memdesc:ga79413c2f550a5c73ff855aea1c1e8782"><td class="mdescLeft">&#160;</td><td class="mdescRight">Write the nonlinear layer to file(s)  <a href="group__cnn.html#ga79413c2f550a5c73ff855aea1c1e8782">More...</a><br/></td></tr>
<tr class="separator:ga79413c2f550a5c73ff855aea1c1e8782"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga02524725a8cef3c8cde7e94fc340b842"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#ga02524725a8cef3c8cde7e94fc340b842">timlCNNNormWriteToFile</a> (FILE *fp1, FILE *fp2, FILE *fp3, <a class="el" href="struct__timlCNNLayer__.html">timlCNNLayer</a> *layer, <a class="el" href="group__util.html#ga8e44b2a87636024736da04ae5a53c1c9">timlUtilParamsLevel</a> level, const char *name, const char *floatFormat, const char *intFormat)</td></tr>
<tr class="memdesc:ga02524725a8cef3c8cde7e94fc340b842"><td class="mdescLeft">&#160;</td><td class="mdescRight">Write the norm layer to file(s)  <a href="group__cnn.html#ga02524725a8cef3c8cde7e94fc340b842">More...</a><br/></td></tr>
<tr class="separator:ga02524725a8cef3c8cde7e94fc340b842"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gaaf5f8b193b721e932cd6d77e183cae1e"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#gaaf5f8b193b721e932cd6d77e183cae1e">timlCNNPoolingWriteToFile</a> (FILE *fp1, FILE *fp2, FILE *fp3, <a class="el" href="struct__timlCNNLayer__.html">timlCNNLayer</a> *layer, <a class="el" href="group__util.html#ga8e44b2a87636024736da04ae5a53c1c9">timlUtilParamsLevel</a> level, const char *name, const char *floatFormat, const char *intFormat)</td></tr>
<tr class="memdesc:gaaf5f8b193b721e932cd6d77e183cae1e"><td class="mdescLeft">&#160;</td><td class="mdescRight">Write the pooling layer to file(s)  <a href="group__cnn.html#gaaf5f8b193b721e932cd6d77e183cae1e">More...</a><br/></td></tr>
<tr class="separator:gaaf5f8b193b721e932cd6d77e183cae1e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gae85f913784a3774a85754329bf89b6f0"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#gae85f913784a3774a85754329bf89b6f0">timlCNNLinearWriteToFile</a> (FILE *fp1, FILE *fp2, FILE *fp3, <a class="el" href="struct__timlCNNLayer__.html">timlCNNLayer</a> *layer, <a class="el" href="group__util.html#ga8e44b2a87636024736da04ae5a53c1c9">timlUtilParamsLevel</a> level, const char *name, const char *floatFormat, const char *intFormat)</td></tr>
<tr class="memdesc:gae85f913784a3774a85754329bf89b6f0"><td class="mdescLeft">&#160;</td><td class="mdescRight">Write the linear layer to file(s)  <a href="group__cnn.html#gae85f913784a3774a85754329bf89b6f0">More...</a><br/></td></tr>
<tr class="separator:gae85f913784a3774a85754329bf89b6f0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gaf45983abe89e99b87d645b1fe2dc44c0"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#gaf45983abe89e99b87d645b1fe2dc44c0">timlCNNInputWriteToFile</a> (FILE *fp1, FILE *fp2, FILE *fp3, <a class="el" href="struct__timlCNNLayer__.html">timlCNNLayer</a> *layer, <a class="el" href="group__util.html#ga8e44b2a87636024736da04ae5a53c1c9">timlUtilParamsLevel</a> level, const char *name, const char *floatFormat, const char *intFormat)</td></tr>
<tr class="memdesc:gaf45983abe89e99b87d645b1fe2dc44c0"><td class="mdescLeft">&#160;</td><td class="mdescRight">Write the input layer to file(s)  <a href="group__cnn.html#gaf45983abe89e99b87d645b1fe2dc44c0">More...</a><br/></td></tr>
<tr class="separator:gaf45983abe89e99b87d645b1fe2dc44c0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gaa6ad7870ae8e2b3b1da182f88079e009"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#gaa6ad7870ae8e2b3b1da182f88079e009">timlCNNTrainingParamsWriteToFile</a> (FILE *fp, <a class="el" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *cnn, const char *name, const char *floatFormat, const char *intFormat)</td></tr>
<tr class="memdesc:gaa6ad7870ae8e2b3b1da182f88079e009"><td class="mdescLeft">&#160;</td><td class="mdescRight">Write the training params to file(s)  <a href="group__cnn.html#gaa6ad7870ae8e2b3b1da182f88079e009">More...</a><br/></td></tr>
<tr class="separator:gaa6ad7870ae8e2b3b1da182f88079e009"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga79524aafb87c8f063b94af5d5a7ffc80"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#ga79524aafb87c8f063b94af5d5a7ffc80">timlCNNDropoutWriteToFile</a> (FILE *fp1, FILE *fp2, FILE *fp3, <a class="el" href="struct__timlCNNLayer__.html">timlCNNLayer</a> *layer, <a class="el" href="group__util.html#ga8e44b2a87636024736da04ae5a53c1c9">timlUtilParamsLevel</a> level, const char *name, const char *floatFormat, const char *intFormat)</td></tr>
<tr class="memdesc:ga79524aafb87c8f063b94af5d5a7ffc80"><td class="mdescLeft">&#160;</td><td class="mdescRight">Write the dropout layer to file(s)  <a href="group__cnn.html#ga79524aafb87c8f063b94af5d5a7ffc80">More...</a><br/></td></tr>
<tr class="separator:ga79524aafb87c8f063b94af5d5a7ffc80"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga33bb2749df4ded66f44492ed7971d556"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#ga33bb2749df4ded66f44492ed7971d556">timlCNNConvReadFromTextFile</a> (FILE *fp1, <a class="el" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *cnn)</td></tr>
<tr class="memdesc:ga33bb2749df4ded66f44492ed7971d556"><td class="mdescLeft">&#160;</td><td class="mdescRight">Read the conv layer from a Matlab compatible text file.  <a href="group__cnn.html#ga33bb2749df4ded66f44492ed7971d556">More...</a><br/></td></tr>
<tr class="separator:ga33bb2749df4ded66f44492ed7971d556"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga086960e00eef59d9a0fe25d42b290c94"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#ga086960e00eef59d9a0fe25d42b290c94">timlCNNTrainingParamsReadFromTextFile</a> (FILE *fp, <a class="el" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *cnn)</td></tr>
<tr class="memdesc:ga086960e00eef59d9a0fe25d42b290c94"><td class="mdescLeft">&#160;</td><td class="mdescRight">Read the training params from a text file.  <a href="group__cnn.html#ga086960e00eef59d9a0fe25d42b290c94">More...</a><br/></td></tr>
<tr class="separator:ga086960e00eef59d9a0fe25d42b290c94"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gaaf83342d056dbe431e6bb19795b6b322"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#gaaf83342d056dbe431e6bb19795b6b322">timlCNNNormReadFromTextFile</a> (FILE *fp1, <a class="el" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *cnn)</td></tr>
<tr class="memdesc:gaaf83342d056dbe431e6bb19795b6b322"><td class="mdescLeft">&#160;</td><td class="mdescRight">Read the nonlinear layer from a text file.  <a href="group__cnn.html#gaaf83342d056dbe431e6bb19795b6b322">More...</a><br/></td></tr>
<tr class="separator:gaaf83342d056dbe431e6bb19795b6b322"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga7d7fbd288d53a4ea552cf66763b050a8"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#ga7d7fbd288d53a4ea552cf66763b050a8">timlCNNPoolingReadFromTextFile</a> (FILE *fp1, <a class="el" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *cnn)</td></tr>
<tr class="memdesc:ga7d7fbd288d53a4ea552cf66763b050a8"><td class="mdescLeft">&#160;</td><td class="mdescRight">Read the pooling layer from a text file.  <a href="group__cnn.html#ga7d7fbd288d53a4ea552cf66763b050a8">More...</a><br/></td></tr>
<tr class="separator:ga7d7fbd288d53a4ea552cf66763b050a8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga53bc772f3fbfba5e529c0f9162efafcc"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#ga53bc772f3fbfba5e529c0f9162efafcc">timlCNNNonlinearReadFromTextFile</a> (FILE *fp1, <a class="el" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *cnn)</td></tr>
<tr class="memdesc:ga53bc772f3fbfba5e529c0f9162efafcc"><td class="mdescLeft">&#160;</td><td class="mdescRight">Read the nonlinear layer from a text file.  <a href="group__cnn.html#ga53bc772f3fbfba5e529c0f9162efafcc">More...</a><br/></td></tr>
<tr class="separator:ga53bc772f3fbfba5e529c0f9162efafcc"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga0098a1467ba70efda263dcec3db75b2a"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#ga0098a1467ba70efda263dcec3db75b2a">timlCNNLinearReadFromTextFile</a> (FILE *fp1, <a class="el" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *cnn)</td></tr>
<tr class="memdesc:ga0098a1467ba70efda263dcec3db75b2a"><td class="mdescLeft">&#160;</td><td class="mdescRight">Read the linear layer from a text file.  <a href="group__cnn.html#ga0098a1467ba70efda263dcec3db75b2a">More...</a><br/></td></tr>
<tr class="separator:ga0098a1467ba70efda263dcec3db75b2a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga3f7013004aea59f09df35e4293b49834"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#ga3f7013004aea59f09df35e4293b49834">timlCNNDropoutReadFromTextFile</a> (FILE *fp1, <a class="el" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *cnn)</td></tr>
<tr class="memdesc:ga3f7013004aea59f09df35e4293b49834"><td class="mdescLeft">&#160;</td><td class="mdescRight">Read the dropout layer from a text file.  <a href="group__cnn.html#ga3f7013004aea59f09df35e4293b49834">More...</a><br/></td></tr>
<tr class="separator:ga3f7013004aea59f09df35e4293b49834"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gabb6e33c3304d338b19194616a2029a42"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#gabb6e33c3304d338b19194616a2029a42">timlCNNInputReadFromTextFile</a> (FILE *fp1, <a class="el" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *cnn)</td></tr>
<tr class="memdesc:gabb6e33c3304d338b19194616a2029a42"><td class="mdescLeft">&#160;</td><td class="mdescRight">Read the input layer from a Matlab compatible text file.  <a href="group__cnn.html#gabb6e33c3304d338b19194616a2029a42">More...</a><br/></td></tr>
<tr class="separator:gabb6e33c3304d338b19194616a2029a42"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga4099a6164a05e55652cebcff8d44034a"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#ga4099a6164a05e55652cebcff8d44034a">timlCNNConvReadFromBinaryFile</a> (FILE *fp2, FILE *fp3, <a class="el" href="struct__timlCNNLayer__.html">timlCNNLayer</a> *layer)</td></tr>
<tr class="memdesc:ga4099a6164a05e55652cebcff8d44034a"><td class="mdescLeft">&#160;</td><td class="mdescRight">Read the conv layer parameters from binary files.  <a href="group__cnn.html#ga4099a6164a05e55652cebcff8d44034a">More...</a><br/></td></tr>
<tr class="separator:ga4099a6164a05e55652cebcff8d44034a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga2a49b61cae4ce1344c41cc756dd9e802"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#ga2a49b61cae4ce1344c41cc756dd9e802">timlCNNLinearReadFromBinaryFile</a> (FILE *fp2, FILE *fp3, <a class="el" href="struct__timlCNNLayer__.html">timlCNNLayer</a> *layer)</td></tr>
<tr class="memdesc:ga2a49b61cae4ce1344c41cc756dd9e802"><td class="mdescLeft">&#160;</td><td class="mdescRight">Read the linear layer parameters from binary files.  <a href="group__cnn.html#ga2a49b61cae4ce1344c41cc756dd9e802">More...</a><br/></td></tr>
<tr class="separator:ga2a49b61cae4ce1344c41cc756dd9e802"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gafc6cc460b2cd26f02f66c17dda3243f2"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#gafc6cc460b2cd26f02f66c17dda3243f2">timlCNNInputReadFromBinaryFile</a> (FILE *fp2, FILE *fp3, <a class="el" href="struct__timlCNNLayer__.html">timlCNNLayer</a> *layer)</td></tr>
<tr class="memdesc:gafc6cc460b2cd26f02f66c17dda3243f2"><td class="mdescLeft">&#160;</td><td class="mdescRight">Read the input layer parameters from binary files.  <a href="group__cnn.html#gafc6cc460b2cd26f02f66c17dda3243f2">More...</a><br/></td></tr>
<tr class="separator:gafc6cc460b2cd26f02f66c17dda3243f2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga65ab44787704761b68e1d733260eaabf"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#ga65ab44787704761b68e1d733260eaabf">timlCNNAssignDevice</a> (<a class="el" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *cnn, int deviceId, int threadId)</td></tr>
<tr class="memdesc:ga65ab44787704761b68e1d733260eaabf"><td class="mdescLeft">&#160;</td><td class="mdescRight">Assign the cnn to a specific device and thread.  <a href="group__cnn.html#ga65ab44787704761b68e1d733260eaabf">More...</a><br/></td></tr>
<tr class="separator:ga65ab44787704761b68e1d733260eaabf"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gac4d98ffda9bdf863563e0677279710c2"><td class="memItemLeft" align="right" valign="top">const char *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#gac4d98ffda9bdf863563e0677279710c2">timlCNNLayerTypeStr</a> (<a class="el" href="struct__timlCNNLayer__.html">timlCNNLayer</a> *layer)</td></tr>
<tr class="memdesc:gac4d98ffda9bdf863563e0677279710c2"><td class="mdescLeft">&#160;</td><td class="mdescRight">Return a string that represents the layer type.  <a href="group__cnn.html#gac4d98ffda9bdf863563e0677279710c2">More...</a><br/></td></tr>
<tr class="separator:gac4d98ffda9bdf863563e0677279710c2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga8a4ba83fc3b8fc29fc31f3b37e8143a0"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#ga8a4ba83fc3b8fc29fc31f3b37e8143a0">timlCNNMemPoolSize</a> (<a class="el" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *cnn)</td></tr>
<tr class="memdesc:ga8a4ba83fc3b8fc29fc31f3b37e8143a0"><td class="mdescLeft">&#160;</td><td class="mdescRight">Return the memory pool size (byte)  <a href="group__cnn.html#ga8a4ba83fc3b8fc29fc31f3b37e8143a0">More...</a><br/></td></tr>
<tr class="separator:ga8a4ba83fc3b8fc29fc31f3b37e8143a0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga4fd1dcf1a199b59bf311168e438fded4"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#ga4fd1dcf1a199b59bf311168e438fded4">timlCNNSupervisedTrainingWithLabelBatchModeOpenMP</a> (<a class="el" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *cnn, float *data, int *label, int dim, int num)</td></tr>
<tr class="memdesc:ga4fd1dcf1a199b59bf311168e438fded4"><td class="mdescLeft">&#160;</td><td class="mdescRight">supervised training with label using openmp  <a href="group__cnn.html#ga4fd1dcf1a199b59bf311168e438fded4">More...</a><br/></td></tr>
<tr class="separator:ga4fd1dcf1a199b59bf311168e438fded4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga4bb1537483995068ac4d250e9e8a7615"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#ga4bb1537483995068ac4d250e9e8a7615">timlCNNClassifyTopNBatchModeOpenMP</a> (<a class="el" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *cnn, float *data, int dim, int num, int *label, float *percent, int topN)</td></tr>
<tr class="memdesc:ga4bb1537483995068ac4d250e9e8a7615"><td class="mdescLeft">&#160;</td><td class="mdescRight">Batch classification using openmp.  <a href="group__cnn.html#ga4bb1537483995068ac4d250e9e8a7615">More...</a><br/></td></tr>
<tr class="separator:ga4bb1537483995068ac4d250e9e8a7615"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga8d682caec3d8703f7622164b6a4612a6"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cnn.html#ga8d682caec3d8703f7622164b6a4612a6">timlCNNClassifyTopNTeamModeOpenMP</a> (<a class="el" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> **cnnTeam, int num, float *data, int dim, int *label, float *percent, int topN)</td></tr>
<tr class="memdesc:ga8d682caec3d8703f7622164b6a4612a6"><td class="mdescLeft">&#160;</td><td class="mdescRight">Batch classification using openmp.  <a href="group__cnn.html#ga8d682caec3d8703f7622164b6a4612a6">More...</a><br/></td></tr>
<tr class="separator:ga8d682caec3d8703f7622164b6a4612a6"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Fri Mar 20 2015 11:26:08 for TIML by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.6
</small></address>
</body>
</html>
